Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Exif.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Exif.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Exif.pm	(revision 34921)
@@ -1063,11 +1373,21 @@
     0x214 => {
         Name => 'ReferenceBlackWhite',
+        Writable => 'rational64u',
+        WriteGroup => 'IFD0',
+        Count => 6,
         Priority => 0,
     },
+  # 0x220 - int32u: 0 (IFD0, Xaiomi Redmi models)
+  # 0x221 - int32u: 0 (IFD0, Xaiomi Redmi models)
+  # 0x222 - int32u: 0 (IFD0, Xaiomi Redmi models)
+  # 0x223 - int32u: 0 (IFD0, Xaiomi Redmi models)
+  # 0x224 - int32u: 0,1 (IFD0, Xaiomi Redmi models)
+  # 0x225 - string: "" (IFD0, Xaiomi Redmi models)
     0x22f => 'StripRowCounts',
     0x2bc => {
         Name => 'ApplicationNotes', # (writable directory!)
+        Format => 'undef',
         Writable => 'int8u',
-        Format => 'undef',
+        WriteGroup => 'IFD0', # (only for Validate)
         Flags => [ 'Binary', 'Protected' ],
         # this could be an XMP block
@@ -1078,12 +1398,30 @@
     },
     0x3e7 => 'USPTOMiscellaneous', #20
-    0x1000 => 'RelatedImageFileFormat', #5
-    0x1001 => 'RelatedImageWidth', #5
+    0x1000 => { #5
+        Name => 'RelatedImageFileFormat',
+        Protected => 1,
+        Writable => 'string',
+        WriteGroup => 'InteropIFD',
+    },
+    0x1001 => { #5
+        Name => 'RelatedImageWidth',
+        Protected => 1,
+        Writable => 'int16u',
+        WriteGroup => 'InteropIFD',
+    },
     0x1002 => { #5
         Name => 'RelatedImageHeight',
         Notes => 'called RelatedImageLength by the DCF spec.',
+        Protected => 1,
+        Writable => 'int16u',
+        WriteGroup => 'InteropIFD',
     },
     # (0x474x tags written by MicrosoftPhoto)
-    0x4746 => 'Rating', #PH
+    0x4746 => { #PH
+        Name => 'Rating',
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
+        Avoid => 1,
+    },
     0x4747 => { # (written by Digital Image Pro)
         Name => 'XP_DIP_XML',
@@ -1092,5 +1430,5 @@
         # http://social.msdn.microsoft.com/Forums/en-US/isvvba/thread/ce6edcbb-8fc2-40c6-ad98-85f5d835ddfb
         ValueConv => '$self->Decode($val,"UCS2","II")',
-    }, 
+    },
     0x4748 => {
         Name => 'StitchInfo',
@@ -1100,5 +1438,109 @@
         },
     },
-    0x4749 => 'RatingPercent', #PH
+    0x4749 => { #PH
+        Name => 'RatingPercent',
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
+        Avoid => 1,
+    },
+    0x7000 => { #JR
+        Name => 'SonyRawFileType',
+        # (only valid if Sony:FileFormat >= ARW 2.0, ref IB)
+        # Writable => 'int16u', (don't allow writes for now)
+        PrintConv => {
+            0 => 'Sony Uncompressed 14-bit RAW',
+            1 => 'Sony Uncompressed 12-bit RAW', #IB
+            2 => 'Sony Compressed RAW', # (lossy, ref IB)
+            3 => 'Sony Lossless Compressed RAW', #IB
+            4 => 'Sony Lossless Compressed RAW 2', #JR (ILCE-1)
+        },
+    },
+    # 0x7001 - int16u[1] (in SubIFD of Sony ARW images) - values: 0,1
+    0x7010 => { #IB
+        Name => 'SonyToneCurve',
+        # int16u[4] (in SubIFD of Sony ARW images -- don't allow writes for now)
+        # - only the middle 4 points are stored (lower comes from black level,
+        #   and upper from data maximum)
+    },
+    # 0x7011 - int16u[4] (in SubIFD of Sony ARW images) - values: "0 4912 8212 12287","4000 7200 10050 12075"
+    # 0x7020 - int32u[1] (in SubIFD of Sony ARW images) - values: 0,3
+    0x7031 => {
+        Name => 'VignettingCorrection',
+        Notes => 'found in Sony ARW images',
+        Protected => 1,
+        Writable => 'int16s',
+        WriteGroup => 'SubIFD',
+        PrintConv => {
+            256 => 'Off',
+            257 => 'Auto',
+            272 => 'Auto (ILCE-1)', #JR
+            511 => 'No correction params available',
+        },
+    },
+    0x7032 => {
+        Name => 'VignettingCorrParams', #forum7640
+        Notes => 'found in Sony ARW images',
+        Protected => 1,
+        Writable => 'int16s',
+        WriteGroup => 'SubIFD',
+        Count => 17,
+    },
+    0x7034 => {
+        Name => 'ChromaticAberrationCorrection',
+        Notes => 'found in Sony ARW images',
+        Protected => 1,
+        Writable => 'int16s',
+        WriteGroup => 'SubIFD',
+        PrintConv => {
+            0 => 'Off',
+            1 => 'Auto',
+            255 => 'No correction params available',
+        },
+    },
+    0x7035 => {
+        Name => 'ChromaticAberrationCorrParams', #forum6509
+        Notes => 'found in Sony ARW images',
+        Protected => 1,
+        Writable => 'int16s',
+        WriteGroup => 'SubIFD',
+        Count => 33,
+    },
+    0x7036 => {
+        Name => 'DistortionCorrection',
+        Notes => 'found in Sony ARW images',
+        Protected => 1,
+        Writable => 'int16s',
+        WriteGroup => 'SubIFD',
+        PrintConv => {
+            0 => 'Off',
+            1 => 'Auto',
+            17 => 'Auto fixed by lens',
+            255 => 'No correction params available',
+        },
+    },
+    0x7037 => {
+        Name => 'DistortionCorrParams', #forum6509
+        Notes => 'found in Sony ARW images',
+        Protected => 1,
+        Writable => 'int16s',
+        WriteGroup => 'SubIFD',
+        Count => 17,
+    },
+    0x74c7 => { #IB (in ARW images from some Sony cameras)
+        Name => 'SonyCropTopLeft',
+        Writable => 'int32u',
+        WriteGroup => 'SubIFD',
+        Count => 2,
+        Permanent => 1,
+        Protected => 1,
+    },
+    0x74c8 => { #IB (in ARW images from some Sony cameras)
+        Name => 'SonyCropSize',
+        Writable => 'int32u',
+        WriteGroup => 'SubIFD',
+        Count => 2,
+        Permanent => 1,
+        Protected => 1,
+    },
     0x800d => 'ImageID', #10
     0x80a3 => { Name => 'WangTag1', Binary => 1 }, #20
@@ -1109,13 +1551,36 @@
         PrintConv => 'length($val) <= 64 ? $val : \$val',
     },
+    # tags 0x80b8-0x80bc are registered to Island Graphics
+    0x80b9 => 'ImageReferencePoints', #29
+    0x80ba => 'RegionXformTackPoint', #29
+    0x80bb => 'WarpQuadrilateral', #29
+    0x80bc => 'AffineTransformMat', #29
     0x80e3 => 'Matteing', #9
     0x80e4 => 'DataType', #9
     0x80e5 => 'ImageDepth', #9
     0x80e6 => 'TileDepth', #9
-    0x827d => 'Model2',
-    0x828d => 'CFARepeatPatternDim', #12
+    # tags 0x8214-0x8219 are registered to Pixar
+    0x8214 => 'ImageFullWidth', #29
+    0x8215 => 'ImageFullHeight', #29
+    0x8216 => 'TextureFormat', #29
+    0x8217 => 'WrapModes', #29
+    0x8218 => 'FovCot', #29
+    0x8219 => 'MatrixWorldToScreen', #29
+    0x821a => 'MatrixWorldToCamera', #29
+    0x827d => 'Model2', #29 (Eastman Kodak)
+    0x828d => { #12
+        Name => 'CFARepeatPatternDim',
+        Protected => 1,
+        Writable => 'int16u',
+        WriteGroup => 'SubIFD',
+        Count => 2,
+    },
     0x828e => {
         Name => 'CFAPattern2', #12
         Format => 'int8u',  # (written incorrectly as 'undef' in Nikon NRW images)
+        Protected => 1,
+        Writable => 'int8u',
+        WriteGroup => 'SubIFD',
+        Count => -1,
     },
     0x828f => { #12
@@ -1132,4 +1597,5 @@
             DirName => 'KodakIFD',
             Start => '$val',
+            MaxSubdirs => 1,
         },
     },
@@ -1138,7 +1604,11 @@
         Groups => { 2 => 'Author' },
         Format => 'undef',
+        Writable => 'string',
+        WriteGroup => 'IFD0',
         Notes => q{
             may contain copyright notices for photographer and editor, separated by a
-            newline in ExifTool
+            newline.  As per the EXIF specification, the newline is replaced by a null
+            byte when writing to file, but this may be avoided by disabling the print
+            conversion
         },
         # internally the strings are separated by a null character in this format:
@@ -1146,17 +1616,40 @@
         # Both:              photographer + NULL + editor + NULL
         # Editor only:       SPACE + NULL + editor + NULL
-        # 1) translate first NULL to a newline, removing trailing blanks
-        # 2) truncate at second NULL and remove trailing blanks
-        # 3) remove trailing newline if it exists
         # (this is done as a RawConv so conditional replaces will work properly)
-        RawConv => '$_=$val; s/ *\0/\n/; s/ *\0.*//s; s/\n$//; $_',
+        RawConv => sub {
+            my ($val, $self) = @_;
+            $val =~ s/ *\0/\n/;  # translate first NULL to a newline, removing trailing blanks
+            $val =~ s/ *\0.*//s; # truncate at second NULL and remove trailing blanks
+            $val =~ s/\n$//;     # remove trailing newline if it exists
+            # decode if necessary (note: this is the only non-'string' EXIF value like this)
+            my $enc = $self->Options('CharsetEXIF');
+            $val = $self->Decode($val,$enc) if $enc;
+            return $val;
+        },
+        RawConvInv => '$val . "\0"',
+        PrintConvInv => sub {
+            my ($val, $self) = @_;
+            # encode if necessary (not automatic because Format is 'undef')
+            my $enc = $self->Options('CharsetEXIF');
+            $val = $self->Encode($val,$enc) if $enc and $val !~ /\0/;
+            if ($val =~ /(.*?)\s*[\n\r]+\s*(.*)/s) {
+                return $1 unless length $2;
+                # photographer copyright set to ' ' if it doesn't exist, according to spec.
+                return((length($1) ? $1 : ' ') . "\0" . $2);
+            }
+            return $val;
+        },
     },
     0x829a => {
         Name => 'ExposureTime',
+        Writable => 'rational64u',
         PrintConv => 'Image::ExifTool::Exif::PrintExposureTime($val)',
+        PrintConvInv => '$val',
     },
     0x829d => {
         Name => 'FNumber',
-        PrintConv => 'sprintf("%.1f",$val)',
+        Writable => 'rational64u',
+        PrintConv => 'Image::ExifTool::Exif::PrintFNumber($val)',
+        PrintConvInv => '$val',
     },
     0x82a5 => { #3
@@ -1171,5 +1664,10 @@
     0x82ab => 'MDPrepTime', #3
     0x82ac => 'MDFileUnits', #3
-    0x830e => 'PixelScale',
+    0x830e => { #30 (GeoTiff)
+        Name => 'PixelScale',
+        Writable => 'double',
+        WriteGroup => 'IFD0',
+        Count => 3,
+    },
     0x8335 => 'AdventScale', #20
     0x8336 => 'AdventRevision', #20
@@ -1179,5 +1677,5 @@
     0x835f => 'UIC4Tag', #23
     0x83bb => { #12
-        Name => 'IPTC-NAA', # (writable directory!)
+        Name => 'IPTC-NAA', # (writable directory! -- but see note below)
         # this should actually be written as 'undef' (see
         # http://www.awaresystems.be/imaging/tiff/tifftags/iptc.html),
@@ -1192,12 +1690,23 @@
             TagTable => 'Image::ExifTool::IPTC::Main',
         },
+        # Note: This directory may be written as a block via the IPTC-NAA tag,
+        # but this technique is not recommended.  Instead, it is better to
+        # write the Extra IPTC tag and let ExifTool decide where it should go.
     },
     0x847e => 'IntergraphPacketData', #3
     0x847f => 'IntergraphFlagRegisters', #3
-    0x8480 => 'IntergraphMatrix',
+    0x8480 => { #30 (GeoTiff, obsolete)
+        Name => 'IntergraphMatrix',
+        Writable => 'double',
+        WriteGroup => 'IFD0',
+        Count => -1,
+    },
     0x8481 => 'INGRReserved', #20
-    0x8482 => {
+    0x8482 => { #30 (GeoTiff)
         Name => 'ModelTiePoint',
         Groups => { 2 => 'Location' },
+        Writable => 'double',
+        WriteGroup => 'IFD0',
+        Count => -1,
     },
     0x84e0 => 'Site', #9
@@ -1249,4 +1758,6 @@
         Name => 'SEMInfo',
         Notes => 'found in some scanning electron microscope images',
+        Writable => 'string',
+        WriteGroup => 'IFD0',
     },
     0x8568 => {
@@ -1259,7 +1770,11 @@
     },
     0x85b8 => 'PixelMagicJBIGOptions', #20
-    0x85d8 => {
+    0x85d7 => 'JPLCartoIFD', #exifprobe (NC)
+    0x85d8 => { #30 (GeoTiff)
         Name => 'ModelTransform',
         Groups => { 2 => 'Location' },
+        Writable => 'double',
+        WriteGroup => 'IFD0',
+        Count => 16,
     },
     0x8602 => { #16
@@ -1279,4 +1794,5 @@
         Name => 'PhotoshopSettings',
         Format => 'binary',
+        WriteGroup => 'IFD0', # (only for Validate)
         SubDirectory => {
             DirName => 'Photoshop',
@@ -1287,4 +1803,5 @@
         Name => 'ExifOffset',
         Groups => { 1 => 'ExifIFD' },
+        WriteGroup => 'IFD0', # (only for Validate)
         SubIFD => 2,
         SubDirectory => {
@@ -1295,4 +1812,5 @@
     0x8773 => {
         Name => 'ICC_Profile',
+        WriteGroup => 'IFD0', # (only for Validate)
         SubDirectory => {
             TagTable => 'Image::ExifTool::ICC_Profile::Main',
@@ -1335,22 +1853,57 @@
     0x8782 => 'T88Options', #20
     0x87ac => 'ImageLayer',
-    0x87af => {
+    0x87af => { #30
         Name => 'GeoTiffDirectory',
-        Format => 'binary',
+        Format => 'undef',
+        Writable => 'int16u',
+        Notes => q{
+            these "GeoTiff" tags may read and written as a block, but they aren't
+            extracted unless specifically requested.  Byte order changes are handled
+            automatically when copying between TIFF images with different byte order
+        },
+        WriteGroup => 'IFD0',
         Binary => 1,
-    },
-    0x87b0 => {
+        RawConv => '$val . GetByteOrder()', # save byte order
+        # swap byte order if necessary
+        RawConvInv => q{
+            return $val if length $val < 2;
+            my $order = substr($val, -2);
+            return $val unless $order eq 'II' or $order eq 'MM';
+            $val = substr($val, 0, -2);
+            return $val if $order eq GetByteOrder();
+            return pack('v*',unpack('n*',$val));
+        },
+    },
+    0x87b0 => { #30
         Name => 'GeoTiffDoubleParams',
-        Format => 'binary',
+        Format => 'undef',
+        Writable => 'double',
+        WriteGroup => 'IFD0',
         Binary => 1,
-    },
-    0x87b1 => {
+        RawConv => '$val . GetByteOrder()', # save byte order
+        # swap byte order if necessary
+        RawConvInv => q{
+            return $val if length $val < 2;
+            my $order = substr($val, -2);
+            return $val unless $order eq 'II' or $order eq 'MM';
+            $val = substr($val, 0, -2);
+            return $val if $order eq GetByteOrder();
+            $val =~ s/(.{4})(.{4})/$2$1/sg; # swap words
+            return pack('V*',unpack('N*',$val));
+        },
+    },
+    0x87b1 => { #30
         Name => 'GeoTiffAsciiParams',
+        Format => 'undef',
+        Writable => 'string',
+        WriteGroup => 'IFD0',
         Binary => 1,
     },
+    0x87be => 'JBIGOptions', #29
     0x8822 => {
         Name => 'ExposureProgram',
         Groups => { 2 => 'Camera' },
         Notes => 'the value of 9 is not standard EXIF, but is used by the Canon EOS 7D',
+        Writable => 'int16u',
         PrintConv => {
             0 => 'Not Defined',
@@ -1369,8 +1922,10 @@
         Name => 'SpectralSensitivity',
         Groups => { 2 => 'Camera' },
+        Writable => 'string',
     },
     0x8825 => {
         Name => 'GPSInfo',
         Groups => { 1 => 'GPS' },
+        WriteGroup => 'IFD0', # (only for Validate)
         Flags => 'SubIFD',
         SubDirectory => {
@@ -1378,4 +1933,5 @@
             TagTable => 'Image::ExifTool::GPS::Main',
             Start => '$val',
+            MaxSubdirs => 1,
         },
     },
@@ -1386,5 +1942,8 @@
             2.3 spec.
         },
+        Writable => 'int16u',
+        Count => -1,
         PrintConv => '$val=~s/\s+/, /g; $val',
+        PrintConvInv => '$val=~tr/,//d; $val',
     },
     0x8828 => {
@@ -1394,9 +1953,21 @@
     },
     0x8829 => 'Interlace', #12
-    0x882a => 'TimeZoneOffset', #12
-    0x882b => 'SelfTimerMode', #12
+    0x882a => { #12
+        Name => 'TimeZoneOffset',
+        Writable => 'int16s',
+        Count => -1, # can be 1 or 2
+        Notes => q{
+            1 or 2 values: 1. The time zone offset of DateTimeOriginal from GMT in
+            hours, 2. If present, the time zone offset of ModifyDate
+        },
+    },
+    0x882b => { #12
+        Name => 'SelfTimerMode',
+        Writable => 'int16u',
+    },
     0x8830 => { #24
         Name => 'SensitivityType',
         Notes => 'applies to EXIF:ISO tag',
+        Writable => 'int16u',
         PrintConv => {
             0 => 'Unknown',
@@ -1410,18 +1981,31 @@
         },
     },
-    0x8831 => 'StandardOutputSensitivity', #24
-    0x8832 => 'RecommendedExposureIndex', #24
-    0x8833 => 'ISOSpeed', #24
+    0x8831 => { #24
+        Name => 'StandardOutputSensitivity',
+        Writable => 'int32u',
+    },
+    0x8832 => { #24
+        Name => 'RecommendedExposureIndex',
+        Writable => 'int32u',
+    },
+    0x8833 => { #24
+        Name => 'ISOSpeed',
+        Writable => 'int32u',
+    },
     0x8834 => { #24
         Name => 'ISOSpeedLatitudeyyy',
         Description => 'ISO Speed Latitude yyy',
+        Writable => 'int32u',
     },
     0x8835 => { #24
         Name => 'ISOSpeedLatitudezzz',
         Description => 'ISO Speed Latitude zzz',
+        Writable => 'int32u',
     },
     0x885c => 'FaxRecvParams', #9
     0x885d => 'FaxSubAddress', #9
     0x885e => 'FaxRecvTime', #9
+    0x8871 => 'FedexEDR', #exifprobe (NC)
+  # 0x8889 - string: "portrait" (ExifIFD, Xiaomi POCO F1)
     0x888a => { #PH
         Name => 'LeafSubIFD',
@@ -1434,7 +2018,16 @@
         },
     },
+  # 0x8891 - int16u: 35 (ExifIFD, Xiaomi POCO F1)
+  # 0x8894 - int16u: 0 (ExifIFD, Xiaomi POCO F1)
+  # 0x8895 - int16u: 0 (ExifIFD, Xiaomi POCO F1)
+  # 0x889a - int16u: 0 (ExifIFD, Xiaomi POCO F1)
+  # 0x89ab - seen "11 100 130 16 0 0 0 0" in IFD0 of TIFF image from IR scanner (forum8470)
     0x9000 => {
         Name => 'ExifVersion',
+        Writable => 'undef',
+        Mandatory => 1,
         RawConv => '$val=~s/\0+$//; $val',  # (some idiots add null terminators)
+        # (allow strings like "2.31" when writing)
+        PrintConvInv => '$val=~tr/.//d; $val=~/^\d{4}$/ ? $val : $val =~ /^\d{3}$/ ? "0$val" : undef',
     },
     0x9003 => {
@@ -1443,5 +2036,9 @@
         Groups => { 2 => 'Time' },
         Notes => 'date/time when original image was taken',
+        Writable => 'string',
+        Shift => 'Time',
+        Validate => 'ValidateExifDate($val)',
         PrintConv => '$self->ConvertDateTime($val)',
+        PrintConvInv => '$self->InverseDateTime($val,0)',
     },
     0x9004 => {
@@ -1449,9 +2046,57 @@
         Groups => { 2 => 'Time' },
         Notes => 'called DateTimeDigitized by the EXIF spec.',
+        Writable => 'string',
+        Shift => 'Time',
+        Validate => 'ValidateExifDate($val)',
         PrintConv => '$self->ConvertDateTime($val)',
+        PrintConvInv => '$self->InverseDateTime($val,0)',
+    },
+    0x9009 => { # undef[44] (or undef[11]) written by Google Plus uploader - PH
+        Name => 'GooglePlusUploadCode',
+        Format => 'int8u',
+        Writable => 'undef',
+        Count => -1,
+    },
+    0x9010 => {
+        Name => 'OffsetTime',
+        Groups => { 2 => 'Time' },
+        Notes => 'time zone for ModifyDate',
+        Writable => 'string',
+        PrintConvInv => q{
+            return "+00:00" if $val =~ /\d{2}Z$/;
+            return sprintf("%s%.2d:%.2d",$1,$2,$3) if $val =~ /([-+])(\d{1,2}):(\d{2})/;
+            return undef;
+        },
+    },
+    0x9011 => {
+        Name => 'OffsetTimeOriginal',
+        Groups => { 2 => 'Time' },
+        Notes => 'time zone for DateTimeOriginal',
+        Writable => 'string',
+        PrintConvInv => q{
+            return "+00:00" if $val =~ /\d{2}Z$/;
+            return sprintf("%s%.2d:%.2d",$1,$2,$3) if $val =~ /([-+])(\d{1,2}):(\d{2})/;
+            return undef;
+        },
+    },
+    0x9012 => {
+        Name => 'OffsetTimeDigitized',
+        Groups => { 2 => 'Time' },
+        Notes => 'time zone for CreateDate',
+        Writable => 'string',
+        PrintConvInv => q{
+            return "+00:00" if $val =~ /\d{2}Z$/;
+            return sprintf("%s%.2d:%.2d",$1,$2,$3) if $val =~ /([-+])(\d{1,2}):(\d{2})/;
+            return undef;
+        },
     },
     0x9101 => {
         Name => 'ComponentsConfiguration',
         Format => 'int8u',
+        Protected => 1,
+        Writable => 'undef',
+        Count => 4,
+        Mandatory => 1,
+        ValueConvInv => '$val=~tr/,//d; $val',  # (so we can copy from XMP with -n)
         PrintConvColumns => 2,
         PrintConv => {
@@ -1485,37 +2130,64 @@
         },
     },
-    0x9102 => 'CompressedBitsPerPixel',
+    0x9102 => {
+        Name => 'CompressedBitsPerPixel',
+        Protected => 1,
+        Writable => 'rational64u',
+    },
+    # 0x9103 - int16u: 1 (found in Pentax XG-1 samples)
     0x9201 => {
         Name => 'ShutterSpeedValue',
+        Notes => 'displayed in seconds, but stored as an APEX value',
         Format => 'rational64s', # Leica M8 patch (incorrectly written as rational64u)
+        Writable => 'rational64s',
         ValueConv => 'abs($val)<100 ? 2**(-$val) : 0',
+        ValueConvInv => '$val>0 ? -log($val)/log(2) : -100',
         PrintConv => 'Image::ExifTool::Exif::PrintExposureTime($val)',
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
     },
     0x9202 => {
         Name => 'ApertureValue',
+        Notes => 'displayed as an F number, but stored as an APEX value',
+        Writable => 'rational64u',
         ValueConv => '2 ** ($val / 2)',
+        ValueConvInv => '$val>0 ? 2*log($val)/log(2) : 0',
         PrintConv => 'sprintf("%.1f",$val)',
-    },
-    0x9203 => 'BrightnessValue',
+        PrintConvInv => '$val',
+    },
+    # Wikipedia: BrightnessValue = Bv = Av + Tv - Sv
+    # ExifTool:  LightValue = LV = Av + Tv - Sv + 5 (5 is the Sv for ISO 100 in Exif usage)
+    0x9203 => {
+        Name => 'BrightnessValue',
+        Writable => 'rational64s',
+    },
     0x9204 => {
         Name => 'ExposureCompensation',
         Format => 'rational64s', # Leica M8 patch (incorrectly written as rational64u)
         Notes => 'called ExposureBiasValue by the EXIF spec.',
+        Writable => 'rational64s',
         PrintConv => 'Image::ExifTool::Exif::PrintFraction($val)',
+        PrintConvInv => '$val',
     },
     0x9205 => {
         Name => 'MaxApertureValue',
+        Notes => 'displayed as an F number, but stored as an APEX value',
         Groups => { 2 => 'Camera' },
+        Writable => 'rational64u',
         ValueConv => '2 ** ($val / 2)',
+        ValueConvInv => '$val>0 ? 2*log($val)/log(2) : 0',
         PrintConv => 'sprintf("%.1f",$val)',
+        PrintConvInv => '$val',
     },
     0x9206 => {
         Name => 'SubjectDistance',
         Groups => { 2 => 'Camera' },
+        Writable => 'rational64u',
         PrintConv => '$val =~ /^(inf|undef)$/ ? $val : "${val} m"',
+        PrintConvInv => '$val=~s/\s*m$//;$val',
     },
     0x9207 => {
         Name => 'MeteringMode',
         Groups => { 2 => 'Camera' },
+        Writable => 'int16u',
         PrintConv => {
             0 => 'Unknown',
@@ -1532,4 +2204,5 @@
         Name => 'LightSource',
         Groups => { 2 => 'Camera' },
+        Writable => 'int16u',
         SeparateTable => 'LightSource',
         PrintConv => \%lightSource,
@@ -1538,4 +2211,5 @@
         Name => 'Flash',
         Groups => { 2 => 'Camera' },
+        Writable => 'int16u',
         Flags => 'PrintHex',
         SeparateTable => 'Flash',
@@ -1545,8 +2219,10 @@
         Name => 'FocalLength',
         Groups => { 2 => 'Camera' },
+        Writable => 'rational64u',
         PrintConv => 'sprintf("%.1f mm",$val)',
+        PrintConvInv => '$val=~s/\s*mm$//;$val',
     },
     # Note: tags 0x920b-0x9217 are duplicates of 0xa20b-0xa217
-    # (The TIFF standard uses 0xa2xx, but you'll find both in images)
+    # (The EXIF standard uses 0xa2xx, but you'll find both in images)
     0x920b => { #12
         Name => 'FlashEnergy',
@@ -1568,7 +2244,11 @@
         },
     },
-    0x9211 => 'ImageNumber', #12
+    0x9211 => { #12
+        Name => 'ImageNumber',
+        Writable => 'int32u',
+    },
     0x9212 => { #12
         Name => 'SecurityClassification',
+        Writable => 'string',
         PrintConv => {
             T => 'Top Secret',
@@ -1579,8 +2259,13 @@
         },
     },
-    0x9213 => 'ImageHistory', #12
+    0x9213 => { #12
+        Name => 'ImageHistory',
+        Writable => 'string',
+    },
     0x9214 => {
         Name => 'SubjectArea',
         Groups => { 2 => 'Camera' },
+        Writable => 'int16u',
+        Count => -1, # 2, 3 or 4 values
     },
     0x9215 => 'ExposureIndex', #12
@@ -1589,17 +2274,16 @@
         Name => 'SensingMethod',
         Groups => { 2 => 'Camera' },
-        Notes => 'values 1 and 6 are not standard EXIF',
         PrintConv => {
-            1 => 'Monochrome area', #12 (not standard EXIF)
+            # (values 1 and 6 are not used by corresponding EXIF tag 0xa217)
+            1 => 'Monochrome area',
             2 => 'One-chip color area',
             3 => 'Two-chip color area',
             4 => 'Three-chip color area',
             5 => 'Color sequential area',
-            6 => 'Monochrome linear', #12 (not standard EXIF)
+            6 => 'Monochrome linear',
             7 => 'Trilinear',
             8 => 'Color sequential linear',
         },
     },
-    0x9213 => 'ImageHistory',
     0x923a => 'CIP3DataFile', #20
     0x923b => 'CIP3Sheet', #20
@@ -1610,22 +2294,37 @@
     0x9286 => {
         Name => 'UserComment',
-        # may consider forcing a Format of 'undef' for this tag because I have
-        # seen other applications write it incorrectly as 'string' or 'int8u'
-        RawConv => 'Image::ExifTool::Exif::ConvertExifText($self,$val)',
+        # I have seen other applications write it incorrectly as 'string' or 'int8u'
+        Format => 'undef',
+        Writable => 'undef',
+        RawConv => 'Image::ExifTool::Exif::ConvertExifText($self,$val,1,$tag)',
+        #  (starts with "ASCII\0\0\0", "UNICODE\0", "JIS\0\0\0\0\0" or "\0\0\0\0\0\0\0\0")
+        RawConvInv => 'Image::ExifTool::Exif::EncodeExifText($self,$val)',
+        # SHOULD ADD SPECIAL LOGIC TO ALLOW CONDITIONAL OVERWRITE OF
+        # "UNKNOWN" VALUES FILLED WITH SPACES
     },
     0x9290 => {
         Name => 'SubSecTime',
         Groups => { 2 => 'Time' },
+        Notes => 'fractional seconds for ModifyDate',
+        Writable => 'string',
         ValueConv => '$val=~s/ +$//; $val', # trim trailing blanks
+        # extract fractional seconds from a full date/time value
+        ValueConvInv => '$val=~/^(\d+)\s*$/ ? $1 : ($val=~/\.(\d+)/ ? $1 : undef)',
     },
     0x9291 => {
         Name => 'SubSecTimeOriginal',
         Groups => { 2 => 'Time' },
+        Notes => 'fractional seconds for DateTimeOriginal',
+        Writable => 'string',
         ValueConv => '$val=~s/ +$//; $val', # trim trailing blanks
+        ValueConvInv => '$val=~/^(\d+)\s*$/ ? $1 : ($val=~/\.(\d+)/ ? $1 : undef)',
     },
     0x9292 => {
         Name => 'SubSecTimeDigitized',
         Groups => { 2 => 'Time' },
+        Notes => 'fractional seconds for CreateDate',
+        Writable => 'string',
         ValueConv => '$val=~s/ +$//; $val', # trim trailing blanks
+        ValueConvInv => '$val=~/^(\d+)\s*$/ ? $1 : ($val=~/\.(\d+)/ ? $1 : undef)',
     },
     # The following 3 tags are found in MSOffice TIFF images
@@ -1644,16 +2343,66 @@
     },
     0x935c => { #3/19
-        Name => 'ImageSourceData',
+        Name => 'ImageSourceData', # (writable directory!)
+        Writable => 'undef',
+        WriteGroup => 'IFD0',
+        SubDirectory => { TagTable => 'Image::ExifTool::Photoshop::DocumentData' },
         Binary => 1,
-    },
+        Protected => 1,     # (because this can be hundreds of megabytes)
+        ReadFromRAF => 1,   # don't load into memory when reading
+    },
+    0x9400 => {
+        Name => 'AmbientTemperature',
+        Notes => 'ambient temperature in degrees C, called Temperature by the EXIF spec.',
+        Writable => 'rational64s',
+        PrintConv => '"$val C"',
+        PrintConvInv => '$val=~s/ ?C//; $val',
+    },
+    0x9401 => {
+        Name => 'Humidity',
+        Notes => 'ambient relative humidity in percent',
+        Writable => 'rational64u',
+    },
+    0x9402 => {
+        Name => 'Pressure',
+        Notes => 'air pressure in hPa or mbar',
+        Writable => 'rational64u',
+    },
+    0x9403 => {
+        Name => 'WaterDepth',
+        Notes => 'depth under water in metres, negative for above water',
+        Writable => 'rational64s',
+    },
+    0x9404 => {
+        Name => 'Acceleration',
+        Notes => 'directionless camera acceleration in units of mGal, or 10-5 m/s2',
+        Writable => 'rational64u',
+    },
+    0x9405 => {
+        Name => 'CameraElevationAngle',
+        Writable => 'rational64s',
+    },
+  # 0x9999 - string: camera settings (ExifIFD, Xiaomi POCO F1)
+  # 0x9aaa - int8u[2176]: ? (ExifIFD, Xiaomi POCO F1)
     0x9c9b => {
         Name => 'XPTitle',
         Format => 'undef',
+        Writable => 'int8u',
+        WriteGroup => 'IFD0',
+        Notes => q{
+            tags 0x9c9b-0x9c9f are used by Windows Explorer; special characters
+            in these values are converted to UTF-8 by default, or Windows Latin1
+            with the -L option.  XPTitle is ignored by Windows Explorer if
+            ImageDescription exists
+        },
         ValueConv => '$self->Decode($val,"UCS2","II")',
+        ValueConvInv => '$self->Encode($val,"UCS2","II") . "\0\0"',
     },
     0x9c9c => {
         Name => 'XPComment',
         Format => 'undef',
+        Writable => 'int8u',
+        WriteGroup => 'IFD0',
         ValueConv => '$self->Decode($val,"UCS2","II")',
+        ValueConvInv => '$self->Encode($val,"UCS2","II") . "\0\0"',
     },
     0x9c9d => {
@@ -1661,19 +2410,32 @@
         Groups => { 2 => 'Author' },
         Format => 'undef',
+        Writable => 'int8u',
+        WriteGroup => 'IFD0',
+        Notes => 'ignored by Windows Explorer if Artist exists',
         ValueConv => '$self->Decode($val,"UCS2","II")',
+        ValueConvInv => '$self->Encode($val,"UCS2","II") . "\0\0"',
     },
     0x9c9e => {
         Name => 'XPKeywords',
         Format => 'undef',
+        Writable => 'int8u',
+        WriteGroup => 'IFD0',
         ValueConv => '$self->Decode($val,"UCS2","II")',
+        ValueConvInv => '$self->Encode($val,"UCS2","II") . "\0\0"',
     },
     0x9c9f => {
         Name => 'XPSubject',
         Format => 'undef',
+        Writable => 'int8u',
+        WriteGroup => 'IFD0',
         ValueConv => '$self->Decode($val,"UCS2","II")',
+        ValueConvInv => '$self->Encode($val,"UCS2","II") . "\0\0"',
     },
     0xa000 => {
         Name => 'FlashpixVersion',
+        Writable => 'undef',
+        Mandatory => 1,
         RawConv => '$val=~s/\0+$//; $val',  # (some idiots add null terminators)
+        PrintConvInv => '$val=~tr/.//d; $val=~/^\d{4}$/ ? $val : undef',
     },
     0xa001 => {
@@ -1684,4 +2446,6 @@
             0xfffd and 0xfffe are also non-standard, and are used by some Sony cameras
         },
+        Writable => 'int16u',
+        Mandatory => 1,
         PrintHex => 1,
         PrintConv => {
